// Written by Marco
Class INFIL_ScoreHighScore extends Object
	Abstract
	Config(INF_HighScores);

struct FPlayerScoreEntry
{
	var config string N;
	var config int S;
};
struct FMapScoreEntry
{
	var config array<FPlayerScoreEntry> S;
	var config name M;
};
var config array<FMapScoreEntry> HS;
var int ActiveMapIndex;
var name InitMapName;

const MaxScoresPerMap=5;

static final function LoadHighScores( name MapName )
{
	local int i;

	Default.InitMapName = MapName;
	for( i=(Array_Size(Default.HS)-1); i>=0; --i )
	{
		if( Default.HS[i].M==MapName )
		{
			Default.ActiveMapIndex = i;
			return;
		}
	}
	Default.ActiveMapIndex = Array_Size(Default.HS);
	Default.HS[Default.ActiveMapIndex].M = MapName;
}
static final function bool GetScoreEntry( byte i, out string PlayerName, out int Score )
{
	if( i>=Array_Size(Default.HS[Default.ActiveMapIndex].S) || Default.HS[Default.ActiveMapIndex].S[i].S==0 )
		return false;
	PlayerName = Default.HS[Default.ActiveMapIndex].S[i].N;
	Score = Default.HS[Default.ActiveMapIndex].S[i].S;
	return true;
}
static final function SaveHighScore( PlayerPawn PP )
{
	local int i,Score,M,Num,j;
	local string S;

	if( Default.InitMapName!=PP.Outer.Name )
		LoadHighScores(PP.Outer.Name); // Just in case highscore option was enabled during match.

	Score = PP.PlayerReplicationInfo.Score;
	if( Score<=0 )
		return;

	M = Default.ActiveMapIndex;
	Num = Array_Size(Default.HS[M].S);
	if( Num<MaxScoresPerMap )
		++Num; // Add new empty slot here now.

	for( i=0; i<Num; ++i )
	{
		if( Default.HS[M].S[i].S<=Score )
		{
			// New high score, insert here new entry.
			S = GetSafeName(PP.PlayerReplicationInfo.PlayerName);

			// First validate player doesn't already have a better score from before.
			if( i>0 )
			{
				for( j=0; j<i; ++j )
					if( Default.HS[M].S[j].N~=S )
						return; // Found it, no need to add more scores.
			}

			if( Default.HS[M].S[i].S>0 ) // Make sure its not an empty uninitialized score entry.
				Array_Insert(Default.HS[M].S,i,1);
			Default.HS[M].S[i].S = Score;
			Default.HS[M].S[i].N = S;

			Log(S@"made it top #"$(i+1)@"with their score.",Default.Class.Outer.Name);

			// Remove any duplicate names for same map.
			for( i=(i+1); i<Array_Size(Default.HS[M].S); ++i )
				if( Default.HS[M].S[i].N~=S )
					Array_Remove(Default.HS[M].S,i--,1);

			// Remove last entries that goes over max scores per map.
			if( Array_Size(Default.HS[M].S)>MaxScoresPerMap )
				Array_Size(Default.HS[M].S,MaxScoresPerMap);
			StaticSaveConfig();
			return;
		}
	}
}
static final function string GetSafeName( string S )
{
	S = ReplaceStr(S,"\"","''");
	S = ReplaceStr(S,"\\","");
	return S;
}

defaultproperties
{
}
